# ioBroker.js-controller

This is a Javascript/Node.js implementation of an ioBroker controller.

**see ioBroker Readme: https://github.com/iobroker/iobroker**

## Manual installation of ioBroker.js-controller on Debian based Linux (Raspbian, Ubuntu, ...)


### [Node.js](http://nodejs.org) (Node.js version >= 0.8, including npm)

* ```wget http://download.iobroker.org/nodejs_0.10.22-1_armhf.deb ; sudo dpkg -i nodejs_0.10.22-1_armhf.deb ; rm nodejs_0.10.22-1_armhf.deb```
#### x86/amd64 Linux, Windows, OSX
[http://nodejs.org/download/](http://nodejs.org/download/)

#### Debian package for ARM (Raspbian, Cubian, ...)
```wget http://ccu.io.mainskater.de/nodejs_0.10.22-1_armhf.deb
sudo dpkg -i nodejs_0.10.22-1_armhf.deb
rm nodejs_0.10.22-1_armhf.deb```



### Install [Redis](http://redis.io/)

* ```sudo apt-get install redis-server```

### Download and Install

* Create and change to the directory under which you want to install ioBroker.

    ```sudo mkdir /opt/iobroker ; sudo chown $USER.$USER /opt/iobroker ; cd /opt/iobroker```
* Clone the repository

    ```git clone https://github.com/ioBroker/ioBroker.js-controller /opt/iobroker/```
* Install Node dependencies

    ```npm install --production```
* Grant execute rights

    ```chmod +x iobroker```
* Do initial database setup

    ```./iobroker setup```

    (if your Redis is not running on localhost you can supply optional arguments --redis &lt;host&gt;)

### Update adapter repository

* Refresh available adapter information

    ```./iobroker update```

### Install admin adapter

This adapter is needed to do basic system administration

*   ```./iobroker add admin --enabled```

### Start ioBroker controller

* run ```./iobroker start``` to start the ioBroker controller in the background
* watch the logfile ```tail -f log/iobroker.log```

or

* run ```node controller.js``` to start the ioBroker controller in foreground and watch the log on console


### Admin UI

The admin adapter starts a webserver that hosts the Admin UI. Default port is 8081, so just open http://&lt;iobroker&gt;:8081/


### Install more adapters

* ```./iobroker add <adapter-name>```
* ```./iobroker add <adapter-url>``` (todo)

After Installation of an Adapter you should edit it's configuration. Go to the tab "instances" in the Admin UI.
By clicking a adapter instance you can directly enable it by checking the enabled checkbox. Press enter to save or escape
to cancel.
To edit the adapters configuration mark the adapter row and click the pencil icon (lower left).



